<?php

$install_path = $_SERVER["DOCUMENT_ROOT"];
$config = $install_path . "/common/common.inc.php";

if(isset($_POST['install_path'])){
	$install_path = $_POST['install_path'];
	$config = $install_path . "/common/common.inc.php";
	
	if(file_exists($config)){
		
		include_once($config);
		
		outputHeader();
		execute();
		outputFooter();
		
		exit;
		
	}else{
		$error = true;
	}
}

outputHeader();
if(@$error)outputError();
outputBody();
outputFooter();

/* --------------------------------------------------------------------------------------- */

function outputBody(){
	global $install_path;
	
	$path = htmlspecialchars($install_path,ENT_QUOTES);

echo <<<HTML
<form method="post">
	<p>SOYCMSのインストール先を選択してください。</p>
	<input type="text" name="install_path" value="$path" size="120" />
	<p>
		<input type="submit" value="実行" />
	</p>
</form>
HTML;
}

function outputError(){
	echo "<p style='color:red'>指定された場所にはSOYCMSがインストールされていません。</p>";	
}


function outputHeader(){
	echo <<<HEADER_HTML
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>SOYCMS Version Up Program (1.1.X -&gt; 1.2.0)</title>
</head>
<body>
<h1>SOYCMS Version Up Program (1.1.X -&gt; 1.2.0)</h1>
HEADER_HTML;
}

function outputFooter(){
	echo <<<FOOTER_HTML
</body>
</html>
FOOTER_HTML;
}


/**
 * バージョンアップ実行
 */
function execute(){
	
	$adminCheckSQL = "select * from AppRole";
	
	switch(SOYCMS_DB_TYPE){
		
		case "mysql":
			$adminSql = array(
				"CREATE TABLE AppRole (" .
				"id INTEGER," .
				" app_id VARCHAR(255)," .
				" user_id INTEGER," .
				" PRIMARY KEY(id)," .
				" unique(user_id,app_id)," .
				" FOREIGN KEY(user_id) REFERENCES Administrator(id)" .
				") TYPE = InnoDB"
			);
			break;
			
		case "sqlite":
			$adminSql = array(
				"CREATE TABLE AppRole (
				  id INTEGER,
				  app_id VARCHAR,
				  user_id INTEGER,
				  PRIMARY KEY(id),
				  unique(user_id,app_id),
				  FOREIGN KEY(user_id)
				    REFERENCES Administrator(id)  
				)"
			);
			break;
	}
	
	SOY2DAOConfig::Dsn(ADMIN_DB_DSN);
	SOY2DAOConfig::user(ADMIN_DB_USER);
	SOY2DAOConfig::pass(ADMIN_DB_PASS);
	
	//admin側を書き換える
	$pdo = SOY2DAO::_getDataSource();
	
	try{
		$pdo->exec($adminCheckSQL);
			
		//既にカラムは追加済み
		echo "<p>";
		echo "管理側DBのバージョンはすでに変更済みです。";
		echo "</p>";
				
	}catch(Exception $e){
		$tmpFailed = false;
	
		foreach($adminSql as $query){
			try{
				$pdo->exec($query);
			}catch(Exception $e){
				$tmpFailed = true;
				$failed["admin"] .= $e->getMessage()."<br/>";
			}
		}
		
		$pdo = null;
	}
		
	//管理側DBへの接続をいったんクリアする必要がある
	SOY2DAO::_releaseDataSource();
	
	$checkSQL = "always update tables";	//無効なSQLを設定する
	
	switch(SOYCMS_DB_TYPE){
		
		case "mysql":
			$sql = array(
				"ALTER TABLE Entry CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE EntryComment CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE EntryTrackback CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE Label CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE EntryLabel CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE Template CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE Page CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE TemplateHistory CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE Block CONVERT TO CHARACTER SET 'utf8'",
				"ALTER TABLE SiteConfig CONVERT TO CHARACTER SET 'utf8'",
			);
			break;
			
		case "sqlite":
			$sql = array();
			break;
	}
	
	//サイトを取得
	
	$siteDAO = SOY2DAOFactory::create("admin.SiteDAO");
	$sites = $siteDAO->get();
	
	
	$failed = array();
	
	foreach($sites as $key => $site){
		
		if(empty($sql))break;
		
		try{
			switch(SOYCMS_DB_TYPE){
				case "mysql":
					$pdo = new PDO($site->getDataSourceName(),ADMIN_DB_USER,ADMIN_DB_PASS,array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
					break;
				case "sqlite":
				default:
					if(!is_writable($site->getPath().".db/sqlite.db")){
						$failed[$key] .= "このファイルへの書き込み権限はありません。<br/>";
					}
					$pdo = new PDO("sqlite:".$site->getPath().".db/sqlite.db","","",array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
					break;
			}
		}catch(Exception $e){
			if(!is_writable($site->getPath().".db/sqlite.db")){
				$failed[$key] .= "データーベースをオープン出来ませんでした。<br/>";
			}
			continue;
		}
		
		try{
			$pdo->exec($checkSQL);
			
			//常にエラー
			throw new Exception();
			
			//既にカラムは追加済み
			echo "<p>";
			echo $site->getSiteName() . "のバージョンは既に変更しているため、スキップしました。";
			echo "</p>";
			continue;
		}catch(Exception $e){
			
		}
		
		$tmpFailed = false;
		
		foreach($sql as $query){
			try{
				$pdo->exec($query);
			}catch(Exception $e){
				$tmpFailed = true;
				$failed[$key] .= $e->getMessage()."<br/>";
			}
		}
		
		if(!$tmpFailed){
			echo "<p>";
			echo $site->getSiteName() . "のデータベースを変更しました。";
			echo "</p>";
		}
	}
	
	if(count($failed) == 0){		
		echo "<p>バージョンアップが完了しました。</p>";
		echo "<p>このバージョンアッププログラムは削除することを推奨します。</p>";
	}else{
		echo "<p>".count($sites) ."個中".count($failed)."個のサイトでバージョンアップが失敗しました。";
		echo "<p>エラーログ</p>";
		foreach($failed as $key => $value){
			
			if($key == "admin"){
				
				echo "<h3>管理側</h3>";
				echo "<pre>" . $value . "</pre>";
					
			}else{
			
				$title = $sites[$key]->getSiteName();
				echo "<h3>サイト名：" . $title. "</h3>";
				echo "<pre>";
				echo $value;
				echo "</pre>";
			}
		}
	}
	
}
?>